<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/flate2-1.0.24/src/zio.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>zio.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../flate2/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../flate2/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../flate2/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">std::io</span>;
<span class="kw">use</span> <span class="ident">std::io::prelude</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">std::mem</span>;

<span class="kw">use</span> <span class="kw">crate</span>::{<span class="ident">Compress</span>, <span class="ident">Decompress</span>, <span class="ident">DecompressError</span>, <span class="ident">FlushCompress</span>, <span class="ident">FlushDecompress</span>, <span class="ident">Status</span>};

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Writer</span><span class="op">&lt;</span><span class="ident">W</span>: <span class="ident">Write</span>, <span class="ident">D</span>: <span class="ident">Ops</span><span class="op">&gt;</span> {
    <span class="ident">obj</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">W</span><span class="op">&gt;</span>,
    <span class="kw">pub</span> <span class="ident">data</span>: <span class="ident">D</span>,
    <span class="ident">buf</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>,
}

<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">Ops</span> {
    <span class="kw">type</span> <span class="ident">Flush</span>: <span class="ident">Flush</span>;
    <span class="kw">fn</span> <span class="ident">total_in</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span>;
    <span class="kw">fn</span> <span class="ident">total_out</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span>;
    <span class="kw">fn</span> <span class="ident">run</span>(
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>,
        <span class="ident">input</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
        <span class="ident">output</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>],
        <span class="ident">flush</span>: <span class="ident"><span class="self">Self</span>::Flush</span>,
    ) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Status</span>, <span class="ident">DecompressError</span><span class="op">&gt;</span>;
    <span class="kw">fn</span> <span class="ident">run_vec</span>(
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>,
        <span class="ident">input</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
        <span class="ident">output</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>,
        <span class="ident">flush</span>: <span class="ident"><span class="self">Self</span>::Flush</span>,
    ) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Status</span>, <span class="ident">DecompressError</span><span class="op">&gt;</span>;
}

<span class="kw">impl</span> <span class="ident">Ops</span> <span class="kw">for</span> <span class="ident">Compress</span> {
    <span class="kw">type</span> <span class="ident">Flush</span> <span class="op">=</span> <span class="ident">FlushCompress</span>;
    <span class="kw">fn</span> <span class="ident">total_in</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span> {
        <span class="self">self</span>.<span class="ident">total_in</span>()
    }
    <span class="kw">fn</span> <span class="ident">total_out</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span> {
        <span class="self">self</span>.<span class="ident">total_out</span>()
    }
    <span class="kw">fn</span> <span class="ident">run</span>(
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>,
        <span class="ident">input</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
        <span class="ident">output</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>],
        <span class="ident">flush</span>: <span class="ident">FlushCompress</span>,
    ) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Status</span>, <span class="ident">DecompressError</span><span class="op">&gt;</span> {
        <span class="prelude-val">Ok</span>(<span class="self">self</span>.<span class="ident">compress</span>(<span class="ident">input</span>, <span class="ident">output</span>, <span class="ident">flush</span>).<span class="ident">unwrap</span>())
    }
    <span class="kw">fn</span> <span class="ident">run_vec</span>(
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>,
        <span class="ident">input</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
        <span class="ident">output</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>,
        <span class="ident">flush</span>: <span class="ident">FlushCompress</span>,
    ) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Status</span>, <span class="ident">DecompressError</span><span class="op">&gt;</span> {
        <span class="prelude-val">Ok</span>(<span class="self">self</span>.<span class="ident">compress_vec</span>(<span class="ident">input</span>, <span class="ident">output</span>, <span class="ident">flush</span>).<span class="ident">unwrap</span>())
    }
}

<span class="kw">impl</span> <span class="ident">Ops</span> <span class="kw">for</span> <span class="ident">Decompress</span> {
    <span class="kw">type</span> <span class="ident">Flush</span> <span class="op">=</span> <span class="ident">FlushDecompress</span>;
    <span class="kw">fn</span> <span class="ident">total_in</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span> {
        <span class="self">self</span>.<span class="ident">total_in</span>()
    }
    <span class="kw">fn</span> <span class="ident">total_out</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span> {
        <span class="self">self</span>.<span class="ident">total_out</span>()
    }
    <span class="kw">fn</span> <span class="ident">run</span>(
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>,
        <span class="ident">input</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
        <span class="ident">output</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>],
        <span class="ident">flush</span>: <span class="ident">FlushDecompress</span>,
    ) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Status</span>, <span class="ident">DecompressError</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">decompress</span>(<span class="ident">input</span>, <span class="ident">output</span>, <span class="ident">flush</span>)
    }
    <span class="kw">fn</span> <span class="ident">run_vec</span>(
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>,
        <span class="ident">input</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
        <span class="ident">output</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>,
        <span class="ident">flush</span>: <span class="ident">FlushDecompress</span>,
    ) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Status</span>, <span class="ident">DecompressError</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">decompress_vec</span>(<span class="ident">input</span>, <span class="ident">output</span>, <span class="ident">flush</span>)
    }
}

<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">Flush</span> {
    <span class="kw">fn</span> <span class="ident">none</span>() -&gt; <span class="self">Self</span>;
    <span class="kw">fn</span> <span class="ident">sync</span>() -&gt; <span class="self">Self</span>;
    <span class="kw">fn</span> <span class="ident">finish</span>() -&gt; <span class="self">Self</span>;
}

<span class="kw">impl</span> <span class="ident">Flush</span> <span class="kw">for</span> <span class="ident">FlushCompress</span> {
    <span class="kw">fn</span> <span class="ident">none</span>() -&gt; <span class="self">Self</span> {
        <span class="ident">FlushCompress::None</span>
    }

    <span class="kw">fn</span> <span class="ident">sync</span>() -&gt; <span class="self">Self</span> {
        <span class="ident">FlushCompress::Sync</span>
    }

    <span class="kw">fn</span> <span class="ident">finish</span>() -&gt; <span class="self">Self</span> {
        <span class="ident">FlushCompress::Finish</span>
    }
}

<span class="kw">impl</span> <span class="ident">Flush</span> <span class="kw">for</span> <span class="ident">FlushDecompress</span> {
    <span class="kw">fn</span> <span class="ident">none</span>() -&gt; <span class="self">Self</span> {
        <span class="ident">FlushDecompress::None</span>
    }

    <span class="kw">fn</span> <span class="ident">sync</span>() -&gt; <span class="self">Self</span> {
        <span class="ident">FlushDecompress::Sync</span>
    }

    <span class="kw">fn</span> <span class="ident">finish</span>() -&gt; <span class="self">Self</span> {
        <span class="ident">FlushDecompress::Finish</span>
    }
}

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">read</span><span class="op">&lt;</span><span class="ident">R</span>, <span class="ident">D</span><span class="op">&gt;</span>(<span class="ident">obj</span>: <span class="kw-2">&amp;mut</span> <span class="ident">R</span>, <span class="ident">data</span>: <span class="kw-2">&amp;mut</span> <span class="ident">D</span>, <span class="ident">dst</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>]) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">R</span>: <span class="ident">BufRead</span>,
    <span class="ident">D</span>: <span class="ident">Ops</span>,
{
    <span class="kw">loop</span> {
        <span class="kw">let</span> (<span class="ident">read</span>, <span class="ident">consumed</span>, <span class="ident">ret</span>, <span class="ident">eof</span>);
        {
            <span class="kw">let</span> <span class="ident">input</span> <span class="op">=</span> <span class="ident">obj</span>.<span class="ident">fill_buf</span>()<span class="question-mark">?</span>;
            <span class="ident">eof</span> <span class="op">=</span> <span class="ident">input</span>.<span class="ident">is_empty</span>();
            <span class="kw">let</span> <span class="ident">before_out</span> <span class="op">=</span> <span class="ident">data</span>.<span class="ident">total_out</span>();
            <span class="kw">let</span> <span class="ident">before_in</span> <span class="op">=</span> <span class="ident">data</span>.<span class="ident">total_in</span>();
            <span class="kw">let</span> <span class="ident">flush</span> <span class="op">=</span> <span class="kw">if</span> <span class="ident">eof</span> {
                <span class="ident">D::Flush::finish</span>()
            } <span class="kw">else</span> {
                <span class="ident">D::Flush::none</span>()
            };
            <span class="ident">ret</span> <span class="op">=</span> <span class="ident">data</span>.<span class="ident">run</span>(<span class="ident">input</span>, <span class="ident">dst</span>, <span class="ident">flush</span>);
            <span class="ident">read</span> <span class="op">=</span> (<span class="ident">data</span>.<span class="ident">total_out</span>() <span class="op">-</span> <span class="ident">before_out</span>) <span class="kw">as</span> <span class="ident">usize</span>;
            <span class="ident">consumed</span> <span class="op">=</span> (<span class="ident">data</span>.<span class="ident">total_in</span>() <span class="op">-</span> <span class="ident">before_in</span>) <span class="kw">as</span> <span class="ident">usize</span>;
        }
        <span class="ident">obj</span>.<span class="ident">consume</span>(<span class="ident">consumed</span>);

        <span class="kw">match</span> <span class="ident">ret</span> {
            <span class="comment">// If we haven&#39;t ready any data and we haven&#39;t hit EOF yet,</span>
            <span class="comment">// then we need to keep asking for more data because if we</span>
            <span class="comment">// return that 0 bytes of data have been read then it will</span>
            <span class="comment">// be interpreted as EOF.</span>
            <span class="prelude-val">Ok</span>(<span class="ident">Status::Ok</span>) <span class="op">|</span> <span class="prelude-val">Ok</span>(<span class="ident">Status::BufError</span>) <span class="kw">if</span> <span class="ident">read</span> <span class="op">==</span> <span class="number">0</span> <span class="op">&amp;&amp;</span> <span class="op">!</span><span class="ident">eof</span> <span class="op">&amp;&amp;</span> <span class="op">!</span><span class="ident">dst</span>.<span class="ident">is_empty</span>() =&gt; {
                <span class="kw">continue</span>
            }
            <span class="prelude-val">Ok</span>(<span class="ident">Status::Ok</span>) <span class="op">|</span> <span class="prelude-val">Ok</span>(<span class="ident">Status::BufError</span>) <span class="op">|</span> <span class="prelude-val">Ok</span>(<span class="ident">Status::StreamEnd</span>) =&gt; <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="ident">read</span>),

            <span class="prelude-val">Err</span>(..) =&gt; {
                <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">io::Error::new</span>(
                    <span class="ident">io::ErrorKind::InvalidInput</span>,
                    <span class="string">&quot;corrupt deflate stream&quot;</span>,
                ))
            }
        }
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">W</span>: <span class="ident">Write</span>, <span class="ident">D</span>: <span class="ident">Ops</span><span class="op">&gt;</span> <span class="ident">Writer</span><span class="op">&lt;</span><span class="ident">W</span>, <span class="ident">D</span><span class="op">&gt;</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">w</span>: <span class="ident">W</span>, <span class="ident">d</span>: <span class="ident">D</span>) -&gt; <span class="ident">Writer</span><span class="op">&lt;</span><span class="ident">W</span>, <span class="ident">D</span><span class="op">&gt;</span> {
        <span class="ident">Writer</span> {
            <span class="ident">obj</span>: <span class="prelude-val">Some</span>(<span class="ident">w</span>),
            <span class="ident">data</span>: <span class="ident">d</span>,
            <span class="ident">buf</span>: <span class="ident">Vec::with_capacity</span>(<span class="number">32</span> <span class="op">*</span> <span class="number">1024</span>),
        }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">finish</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="kw">loop</span> {
            <span class="self">self</span>.<span class="ident">dump</span>()<span class="question-mark">?</span>;

            <span class="kw">let</span> <span class="ident">before</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">data</span>.<span class="ident">total_out</span>();
            <span class="self">self</span>.<span class="ident">data</span>.<span class="ident">run_vec</span>(<span class="kw-2">&amp;</span>[], <span class="kw-2">&amp;mut</span> <span class="self">self</span>.<span class="ident">buf</span>, <span class="ident">D::Flush::finish</span>())<span class="question-mark">?</span>;
            <span class="kw">if</span> <span class="ident">before</span> <span class="op">==</span> <span class="self">self</span>.<span class="ident">data</span>.<span class="ident">total_out</span>() {
                <span class="kw">return</span> <span class="prelude-val">Ok</span>(());
            }
        }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">replace</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">w</span>: <span class="ident">W</span>) -&gt; <span class="ident">W</span> {
        <span class="self">self</span>.<span class="ident">buf</span>.<span class="ident">truncate</span>(<span class="number">0</span>);
        <span class="ident">mem::replace</span>(<span class="self">self</span>.<span class="ident">get_mut</span>(), <span class="ident">w</span>)
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get_ref</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="ident">W</span> {
        <span class="self">self</span>.<span class="ident">obj</span>.<span class="ident">as_ref</span>().<span class="ident">unwrap</span>()
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get_mut</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="kw-2">&amp;mut</span> <span class="ident">W</span> {
        <span class="self">self</span>.<span class="ident">obj</span>.<span class="ident">as_mut</span>().<span class="ident">unwrap</span>()
    }

    <span class="comment">// Note that this should only be called if the outer object is just about</span>
    <span class="comment">// to be consumed!</span>
    <span class="comment">//</span>
    <span class="comment">// (e.g. an implementation of `into_inner`)</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">take_inner</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="ident">W</span> {
        <span class="self">self</span>.<span class="ident">obj</span>.<span class="ident">take</span>().<span class="ident">unwrap</span>()
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">is_present</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">obj</span>.<span class="ident">is_some</span>()
    }

    <span class="comment">// Returns total written bytes and status of underlying codec</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">write_with_status</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">buf</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>(<span class="ident">usize</span>, <span class="ident">Status</span>)<span class="op">&gt;</span> {
        <span class="comment">// miniz isn&#39;t guaranteed to actually write any of the buffer provided,</span>
        <span class="comment">// it may be in a flushing mode where it&#39;s just giving us data before</span>
        <span class="comment">// we&#39;re actually giving it any data. We don&#39;t want to spuriously return</span>
        <span class="comment">// `Ok(0)` when possible as it will cause calls to write_all() to fail.</span>
        <span class="comment">// As a result we execute this in a loop to ensure that we try our</span>
        <span class="comment">// darndest to write the data.</span>
        <span class="kw">loop</span> {
            <span class="self">self</span>.<span class="ident">dump</span>()<span class="question-mark">?</span>;

            <span class="kw">let</span> <span class="ident">before_in</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">data</span>.<span class="ident">total_in</span>();
            <span class="kw">let</span> <span class="ident">ret</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">data</span>.<span class="ident">run_vec</span>(<span class="ident">buf</span>, <span class="kw-2">&amp;mut</span> <span class="self">self</span>.<span class="ident">buf</span>, <span class="ident">D::Flush::none</span>());
            <span class="kw">let</span> <span class="ident">written</span> <span class="op">=</span> (<span class="self">self</span>.<span class="ident">data</span>.<span class="ident">total_in</span>() <span class="op">-</span> <span class="ident">before_in</span>) <span class="kw">as</span> <span class="ident">usize</span>;
            <span class="kw">let</span> <span class="ident">is_stream_end</span> <span class="op">=</span> <span class="macro">matches!</span>(<span class="ident">ret</span>, <span class="prelude-val">Ok</span>(<span class="ident">Status::StreamEnd</span>));

            <span class="kw">if</span> <span class="op">!</span><span class="ident">buf</span>.<span class="ident">is_empty</span>() <span class="op">&amp;&amp;</span> <span class="ident">written</span> <span class="op">==</span> <span class="number">0</span> <span class="op">&amp;&amp;</span> <span class="ident">ret</span>.<span class="ident">is_ok</span>() <span class="op">&amp;&amp;</span> <span class="op">!</span><span class="ident">is_stream_end</span> {
                <span class="kw">continue</span>;
            }
            <span class="kw">return</span> <span class="kw">match</span> <span class="ident">ret</span> {
                <span class="prelude-val">Ok</span>(<span class="ident">st</span>) =&gt; <span class="kw">match</span> <span class="ident">st</span> {
                    <span class="ident">Status::Ok</span> <span class="op">|</span> <span class="ident">Status::BufError</span> <span class="op">|</span> <span class="ident">Status::StreamEnd</span> =&gt; <span class="prelude-val">Ok</span>((<span class="ident">written</span>, <span class="ident">st</span>)),
                },
                <span class="prelude-val">Err</span>(..) =&gt; <span class="prelude-val">Err</span>(<span class="ident">io::Error::new</span>(
                    <span class="ident">io::ErrorKind::InvalidInput</span>,
                    <span class="string">&quot;corrupt deflate stream&quot;</span>,
                )),
            };
        }
    }

    <span class="kw">fn</span> <span class="ident">dump</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="comment">// TODO: should manage this buffer not with `drain` but probably more of</span>
        <span class="comment">// a deque-like strategy.</span>
        <span class="kw">while</span> <span class="op">!</span><span class="self">self</span>.<span class="ident">buf</span>.<span class="ident">is_empty</span>() {
            <span class="kw">let</span> <span class="ident">n</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">obj</span>.<span class="ident">as_mut</span>().<span class="ident">unwrap</span>().<span class="ident">write</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">buf</span>)<span class="question-mark">?</span>;
            <span class="kw">if</span> <span class="ident">n</span> <span class="op">==</span> <span class="number">0</span> {
                <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">io::ErrorKind::WriteZero</span>.<span class="ident">into</span>());
            }
            <span class="self">self</span>.<span class="ident">buf</span>.<span class="ident">drain</span>(..<span class="ident">n</span>);
        }
        <span class="prelude-val">Ok</span>(())
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">W</span>: <span class="ident">Write</span>, <span class="ident">D</span>: <span class="ident">Ops</span><span class="op">&gt;</span> <span class="ident">Write</span> <span class="kw">for</span> <span class="ident">Writer</span><span class="op">&lt;</span><span class="ident">W</span>, <span class="ident">D</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">write</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">buf</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">write_with_status</span>(<span class="ident">buf</span>).<span class="ident">map</span>(<span class="op">|</span><span class="ident">res</span><span class="op">|</span> <span class="ident">res</span>.<span class="number">0</span>)
    }

    <span class="kw">fn</span> <span class="ident">flush</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">data</span>
            .<span class="ident">run_vec</span>(<span class="kw-2">&amp;</span>[], <span class="kw-2">&amp;mut</span> <span class="self">self</span>.<span class="ident">buf</span>, <span class="ident">D::Flush::sync</span>())
            .<span class="ident">unwrap</span>();

        <span class="comment">// Unfortunately miniz doesn&#39;t actually tell us when we&#39;re done with</span>
        <span class="comment">// pulling out all the data from the internal stream. To remedy this we</span>
        <span class="comment">// have to continually ask the stream for more memory until it doesn&#39;t</span>
        <span class="comment">// give us a chunk of memory the same size as our own internal buffer,</span>
        <span class="comment">// at which point we assume it&#39;s reached the end.</span>
        <span class="kw">loop</span> {
            <span class="self">self</span>.<span class="ident">dump</span>()<span class="question-mark">?</span>;
            <span class="kw">let</span> <span class="ident">before</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">data</span>.<span class="ident">total_out</span>();
            <span class="self">self</span>.<span class="ident">data</span>
                .<span class="ident">run_vec</span>(<span class="kw-2">&amp;</span>[], <span class="kw-2">&amp;mut</span> <span class="self">self</span>.<span class="ident">buf</span>, <span class="ident">D::Flush::none</span>())
                .<span class="ident">unwrap</span>();
            <span class="kw">if</span> <span class="ident">before</span> <span class="op">==</span> <span class="self">self</span>.<span class="ident">data</span>.<span class="ident">total_out</span>() {
                <span class="kw">break</span>;
            }
        }

        <span class="self">self</span>.<span class="ident">obj</span>.<span class="ident">as_mut</span>().<span class="ident">unwrap</span>().<span class="ident">flush</span>()
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">W</span>: <span class="ident">Write</span>, <span class="ident">D</span>: <span class="ident">Ops</span><span class="op">&gt;</span> <span class="ident">Drop</span> <span class="kw">for</span> <span class="ident">Writer</span><span class="op">&lt;</span><span class="ident">W</span>, <span class="ident">D</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">drop</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">obj</span>.<span class="ident">is_some</span>() {
            <span class="kw">let</span> <span class="kw">_</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">finish</span>();
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="flate2" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>